// BitmapLoadView.cpp : Implementierung der Klasse CBitmapLoadView
//

#include "stdafx.h"
#include "BitmapLoad.h"

#include "BitmapLoadDoc.h"
#include "BitmapLoadView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CBitmapLoadView

IMPLEMENT_DYNCREATE(CBitmapLoadView, CScrollView)

BEGIN_MESSAGE_MAP(CBitmapLoadView, CScrollView)
	// Standarddruckbefehle
	ON_COMMAND(ID_FILE_PRINT, &CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, &CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, &CScrollView::OnFilePrintPreview)
	ON_COMMAND (ID_LOADBITMAP, CBitmapLoadView::OnLoadBitmap)
END_MESSAGE_MAP()

// CBitmapLoadView-Erstellung/Zerstrung

CBitmapLoadView::CBitmapLoadView()
{
	// TODO: Hier Code zur Konstruktion einfgen

	//Kein Bild geladen.
	this->image = NULL;
}

CBitmapLoadView::~CBitmapLoadView()
{
}

BOOL CBitmapLoadView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ndern Sie hier die Fensterklasse oder die Darstellung, indem Sie
	//  CREATESTRUCT cs modifizieren.

	return CScrollView::PreCreateWindow(cs);
}

// CBitmapLoadView-Zeichnung

void CBitmapLoadView::OnDraw(CDC* pDC)
{
	CBitmapLoadDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

	// TODO: Code zum Zeichnen der systemeigenen Daten hinzufgen

	//Ist eine Bitmap geladen ?
	if (this->image != NULL)
	{
		//Wenn erfolgreich, dann Bitmap zeichnen:
		BOOL bDraw = this->image->Draw ( (HDC) (*pDC), 0, 0 );
		if (bDraw == FALSE)
			pDC->DrawText (_T("Bitmap-Zeichnen schlug fehl !"), &CRect (0, 0, 100, 20), DT_NOCLIP );
	} 
	else
	{
		//Keine Bilddatei: dem User Bescheid geben:
		pDC->DrawText (_T("Bitte Bitmap-Datei auswhlen !"), &CRect (0, 0, 100, 20), DT_NOCLIP );

	} //Ende if/else (Dateiname angegeben)
}

void CBitmapLoadView::OnInitialUpdate()
{
	CScrollView::OnInitialUpdate();

	CSize sizeTotal;
	// TODO: Gesamte Gre dieser Ansicht berechnen
	sizeTotal.cx = sizeTotal.cy = 100;
	SetScrollSizes(MM_TEXT, sizeTotal);

	//Speichern der Original-Gre, damit wir sie beim Laden eines 
	//kleineren Bildes zurcksetzen knnen.
	this->sizeInitial = this->GetTotalSize();
}


// CBitmapLoadView drucken

BOOL CBitmapLoadView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// Standardvorbereitung
	return DoPreparePrinting(pInfo);
}

void CBitmapLoadView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: Zustzliche Initialisierung vor dem Drucken hier einfgen
}

void CBitmapLoadView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: Bereinigung nach dem Drucken einfgen
}


// CBitmapLoadView-Diagnose

#ifdef _DEBUG
void CBitmapLoadView::AssertValid() const
{
	CScrollView::AssertValid();
}

void CBitmapLoadView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}

CBitmapLoadDoc* CBitmapLoadView::GetDocument() const // Nicht-Debugversion ist inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CBitmapLoadDoc)));
	return (CBitmapLoadDoc*)m_pDocument;
}
#endif //_DEBUG


// CBitmapLoadView-Meldungshandler


/**@\brief Laden einer Bitmap.
 * Ein Dialog zur Dateiauswahl wird angezeigt und die
 * darin gewhlte Bilddatei in die View gepackt.
 */
void CBitmapLoadView::OnLoadBitmap(void)
{
	//Dialog fr Dateiffnen erzeugen:
	CFileDialog dialogFileOpen (TRUE, //Dialog zum Datei-ffnen verwenden (FALSE wre Save).
		0,	//Default-Wert
		0,  //Default-Wert
		OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT, //Default-Wert
		_T("Bitmap-Dateien (*.bmp)|*.bmp|JPEG-Bilder (*.jpeg, *.jpg)|*.jpeg;*.jpg|Gif-Bilder (*.gif)|*.gif|Portable Network Graphics (*.png)|*.png||"),       //Filterung in Combobox des Dateityps, nach dem Pipe-Symbol der Endungs-Filter. Muss mit Doppel-Pipe enden !
		this, //Parent-Fenster
		0);   //Default-Wert
	//Dialog anzeigen und auf OK-Klick warten:
	if (dialogFileOpen.DoModal() != IDOK)
		return;

	//Datei laden und in Membervariablen speichern:
	CString sBitmapFile = dialogFileOpen.GetFileName ();
	//Die Bitmap laden.
	//Falls es eine alte gibt, diese lschen.
	if (this->image != NULL)
		delete this->image;
	this->image = new CImage ();
	HRESULT resultLoad = this->image->Load (sBitmapFile);

	//Laden der Bitmap kann fehlschlagen:
	if (resultLoad == S_OK)
	{
		//Erfolgreich: Anpassen des Scrollbereichs.
		//Falls er kleiner wird als der Initialwert, dann darauf setzen.
		int iWidth = this->image->GetWidth();
		if (iWidth < this->sizeInitial.cx)
			iWidth = this->sizeInitial.cx;
		int iHeight = this->image->GetHeight();
		if (iHeight < this->sizeInitial.cy)
			iHeight = this->sizeInitial.cy;
		this->SetScrollSizes (MM_TEXT, CSize (iWidth, iHeight) );
	}
	else
	{
		//Laden der Bitmap schlug fehl: Fehlernummer holen 
		//und ausgeben.
		//GetLastError aufrufen bevor die Scrollview-Gre angepat wird !
		DWORD dwLastError = ::GetLastError();

		//Bitmap lschen, ist nicht brauchbar.
		delete this->image;
		this->image = NULL;
		//SCrollsize zurcksetzen:
		this->SetScrollSizes (MM_TEXT, this->sizeInitial );

		//In Fehlermeldung die Fehlernummer setzen:
		CString sMessage = _T("");
		sMessage.Format (_T("Bitmap-Laden schlug fehl. GetLastError = %d!"), dwLastError);
		
		//Fehlermeldung ausgeben.
		AfxMessageBox (sMessage);
	}
	
	//Und Neuzeichnen:
	this->GetDocument()->UpdateAllViews(NULL);

}
